local GearEvaluator = _G.GearEvaluator
local GearEvaluator_AutoSets = GearEvaluator:NewModule("AutoSets", "AceHook-3.0")

function GearEvaluator_AutoSets:OnEnable()
  if (not GearEvaluator.db.profile.bestscores) then
    GearEvaluator.db.profile.bestscores = {}
  end

  self:SecureHook(GearEvaluator, 'UpdateScore')
  self:Hook(GearEvaluator, 'UpdateEvaluatorFunction')
end

function GearEvaluator_AutoSets:OnDisable()
  self:Unhook(GearEvaluator, 'UpdateEvaluatorFunction')
  self:Unhook(GearEvaluator, 'UpdateScore')
end

function GearEvaluator_AutoSets:UpdateScore(object, name)
  local setname, icon = GetEquipmentSetInfoByName(name)

  if (setname) then
    local setgear = {}
    local setitems = GetEquipmentSetItemIDs(name)

    for i = 1, #setitems do
      local _, link = GetItemInfo(setitems[i])
      setgear[i] = link
    end

	local oldscore = GearEvaluator.db.profile.bestscores[name] or 0

    if(GearEvaluator.scores[name] > oldscore) then
	  GearEvaluator:Print("Updating set "..name.." with new best score "..GearEvaluator.scores[name])
      SaveEquipmentSet(name, icon)
	  GearEvaluator.db.profile.bestscores[name] = GearEvaluator.scores[name]
    end
  end
end

function GearEvaluator_AutoSets:UpdateEvaluatorFunction(object, info, func)
  GearEvaluator.db.profile.bestscores[name] = 0
end
